//DESCRIPTION: ConvertSwatchToGrayscale v. 1.1. A simple script which converts the current color to grayscale.
//(c) In-Tools.com This script is provided "as-is" and we take no responsibility whatsoever for results of its use.

#targetengine "In-Tools"

(function(){

var actionName = "Convert to Grayscale";
var action = app.scriptMenuActions.item(actionName);
if(action == null) {
	var action = app.scriptMenuActions.add(actionName);
}
action.addEventListener("onInvoke", makeSwatchGreyscale);	
	
var cPickerMenu = app.menus.item("$ID/ColorPickerPanelPopup");
var prevMenu = cPickerMenu.menuElements.item("$ID/RGB");

cPickerMenu.menuItems.add(action,LocationOptions.AFTER,prevMenu);
cPickerMenu.menuSeparators.add(LocationOptions.AFTER,prevMenu);

})();

function makeSwatchGreyscale(){
	var settings = app.strokeFillProxySettings;
	switch(settings.active){
		case StrokeFillProxyOptions.STROKE:
			var color = settings.strokeColor;
			break;
		case StrokeFillProxyOptions.FILL:
			var color = settings.fillColor;
			break;
	}
	color.space = ColorSpace.RGB
	
	var r = color.colorValue[0];
	var g = color.colorValue[1];
	var b = color.colorValue[2];
	
	var brightness = Math.sqrt((r*r*.241) + (g*g*.691) + (b*b*.068));
	var calcValue = 100 - (brightness/255 * 100);
	calcValue+=(calcValue/5.5);

	if(calcValue > 100){calcValue = 100;}
	if(calcValue < 0){calcValue = 0;}
 
	color.space = ColorSpace.CMYK;
	color.colorValue = [0,0,0,calcValue];
}